
vec3 get_lava_fog(float dist, vec3 color, vec3 fogColor) {
    const vec3 LAVA_FOG_COLOR = vec3(0.9, 0.4, 0.15);
    const vec3 PSNOW_FOG_COLOR = vec3(0.45, 0.67, 1.0);
    
    switch(isEyeInWater) {
        case 1:
            vec3 UnderwaterCol = fogColor*0.5;
            dist = clamp(dist/125, 0, 1);
            dist = 1.0 - exp(-3.0 * dist);
            return mix(color, UnderwaterCol, dist);
        case 2:
            dist = clamp(dist/2, 0, 1);
            return mix(color, LAVA_FOG_COLOR, dist);
        case 3:
            dist = clamp(dist/2, 0, 1);
            return mix(color, PSNOW_FOG_COLOR, dist);
    }
    return color;
}

vec3 get_border_fog(float strength, vec3 color, vec3 SkyColor) {
    strength *= strength;
    #ifndef DIMENSION_NETHER
    strength *= strength;
    strength *= strength;
    #endif
    strength = 1.0 - exp(-3.0 * strength); 
    strength = clamp(strength, 0, 1);
    return mix(color, SkyColor, strength);
}
