#include "/lib/all_the_uniforms.glsl"
varying vec2 texcoord;
#include "/lib/tonemap.glsl"
#include "/lib/blur.glsl"
#include "/lib/settings.glsl"

// Color adjustments, Bloom final

/* DRAWBUFFERS:0 */

void main() {
	gl_FragData[0] = texture2D(colortex0, texcoord);
	#ifdef BLOOM 
		float Offset = 0;
		vec4 FinalBloom = vec4(0, 0, 0, 1);
		for(int i = 2; i <= 2+BLOOM_SIZE; i++) {
			FinalBloom += texture2D(colortex1, texcoord/pow(2, i)+Offset);
			Offset += 1/pow(2, i);
		}
		gl_FragData[0] += FinalBloom * BLOOM_STRENGTH;
	#endif
	
	gl_FragData[0].xyz = ACESFilm(gl_FragData[0].xyz);
	gl_FragData[0].xyz = apply_contrast(gl_FragData[0].xyz, CONTRAST);
	gl_FragData[0].xyz = apply_vibrance(gl_FragData[0].xyz, VIBRANCE);
	gl_FragData[0].xyz = apply_saturation(gl_FragData[0].xyz, SATURATION);
}
