#include "/lib/all_the_uniforms.glsl"
uniform sampler2D lightmap;
uniform sampler2D gtexture;

varying vec2 LightmapCoords;
varying vec2 texcoord;
varying vec4 glcolor;
varying vec3 ViewPos;

#include "/lib/util.glsl"
#include "/lib/tonemap.glsl"

#include "/lib/settings.glsl"
#include "/global/sky.glsl"

void main() {
	/* DRAWBUFFERS:02 */
	vec4 data = texture2D(gtexture, texcoord) * glcolor;
	vec4 SkyColor = vec4(calcSkyColor(normalize(ViewPos)), 1);
	gl_FragData[0] = SkyColor;
	if(data.r == data.g && data.g == data.b && data.r > 0.0) { // This only includes stars
		gl_FragData[0] -= data;
		vec3 NPlayerPos = normalize(to_player_pos(ViewPos));
		gl_FragData[0] = vec4(2) * fbm(NPlayerPos.xy*64, 1) * max(sqrt(NPlayerPos.y)+0.2, 0) * data.a * 2;
	}
	#ifdef BORDER_FOG
    gl_FragData[1].xyz = SkyColor.xyz;
	#endif
	
}
