#include "/lib/all_the_uniforms.glsl"
uniform sampler2D lightmap;
uniform sampler2D gtexture;

varying vec2 LightmapCoords;
varying vec2 texcoord;
varying vec4 glcolor;

/* DRAWBUFFERS:0 */

#include "/global/lighting.fsh"

void main() {
	gl_FragData[0] = texture2D(gtexture, texcoord) * glcolor;
	vec3 TweakedLM = tweak_lightmap(LightmapCoords);
	gl_FragData[0] *= vec4(TweakedLM, 1);
	
	if (gl_FragData[0].a < 0.1) {
		discard;
	}
	gl_FragData[0] = vec4(apply_saturation(gl_FragData[0].rgb, 0.5), 0.25);
}
